/* -*-C-*- */
/* $Id: plDevs.h.cmake 8359 2008-04-07 01:30:33Z hbabcock $

    Maurice LeBrun
    IFS, University of Texas at Austin
    18-Jul-1994

    Contains macro definitions that determine what device drivers are
    compiled into the PLplot library.  On a Unix system, typically the
    configure script builds plDevs.h from plDevs.h.in.  Elsewhere, it's
    best to hand-configure a plDevs.h file and keep it with the
    system-specific files.

    Copyright (C) 2004  Andrew Roach
    Copyright (C) 2005  Thomas J. Duck
    Copyright (C) 2006  Andrew Ross
    Copyright (C) 2006  Alan W. Irwin

    This file is part of PLplot.

    PLplot is free software; you can redistribute it and/or modify
    it under the terms of the GNU Library General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    PLplot is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with PLplot; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

*/

#ifndef __PLDEVS_H__
#define __PLDEVS_H__

/* #undef PDL_aqt */
/* #undef PLD_plmeta */
#define PLD_null
#define PLD_xterm
#define PLD_tek4010
#define PLD_tek4010f
#define PLD_tek4107
#define PLD_tek4107f
#define PLD_mskermit
#define PLD_vlt
#define PLD_versaterm
#define PLD_conex
/* #undef PLD_linuxvga */
#define PLD_dg300
#define PLD_png
#define PLD_jpeg
#define PLD_gif
/* #undef PLD_cgm */
#define PLD_ps
#define PLD_xfig
#define PLD_ljiip
#define PLD_ljii
#define PLD_lj_hpgl
#define PLD_hp7470
#define PLD_hp7580
#define PLD_imp
#define PLD_xwin
#define PLD_tk
#define PLD_pbm
#define PLD_gcw
/* #undef PLD_gnome */
#define PLD_pstex
#define PLD_psttf
#define PLD_ntk
#define PLD_tkwin
#define PLD_mem
/* #undef PLD_wingcc */
#define PLD_wxwidgets
#define PLD_svg
/* #undef PLD_pdf */
#define PLD_xcairo
#define PLD_pdfcairo
#define PLD_pscairo
#define PLD_svgcairo
#define PLD_pngcairo
/* #undef PLD_memcairo */
/* #undef PLD_extcairo */


#endif	/* __PLDEVS_H__ */
